#include <stdexcept>
#include "device.h"

using namespace std;

namespace Msp {
namespace AL {

Device::Device()
{
	dev = alcOpenDevice(0);
	if(!dev)
		throw runtime_error("Couldn't get OpenAL device");
}

Device::Device(const string &spec)
{
	dev = alcOpenDevice(spec.c_str());
	if(!dev)
		throw runtime_error("Couldn't get OpenAL device");
}

Device::~Device()
{
	alcCloseDevice(dev);
}

} // namespace AL
} // namespace Msp
