#ifndef MSP_AL_OGGDECODER_H_
#define MSP_AL_OGGDECODER_H_

#include <stdexcept>
#include "sounddecoder.h"

namespace Msp {
namespace AL {

class ogg_error: public std::runtime_error
{
public:
	ogg_error(const std::string &, int);
	virtual ~ogg_error() throw() { }

private:
	static std::string get_message(int);
};


class OggDecoder: public SoundDecoder
{
private:
	struct Private;

	Private *priv;

public:
	OggDecoder(IO::Seekable &);
	~OggDecoder();

	static bool detect(const std::string &);

	virtual void rewind();
	virtual unsigned read(char *, unsigned);
};

} // namespace AL
} // namespace Msp

#endif
